LibreOffice: _uno_ExtEnvironment Struct Reference

LibreOffice LibreOffice 5.2 SDK C/C++ API Reference

Public Attributes | List of all members
_uno_ExtEnvironment Struct Reference

The binary specification of an UNO environment supporting interface registration. More...

`#include <environment.h>`

## Public Attributes
uno_Environment | aBase
| inherits all members of an uno_Environment More...
void(* | registerInterface )(struct _uno_ExtEnvironment *pEnv, void **ppInterface, rtl_uString *pOId, struct _typelib_InterfaceTypeDescription *pTypeDescr)
| Registers an interface of this environment. More...
void(* | registerProxyInterface )(struct _uno_ExtEnvironment *pEnv, void **ppProxy, uno_freeProxyFunc freeProxy, rtl_uString *pOId, struct _typelib_InterfaceTypeDescription *pTypeDescr)
| Registers a proxy interface of this environment that can be reanimated and is freed explicitly by this environment. More...
void(* | revokeInterface )(struct _uno_ExtEnvironment *pEnv, void *pInterface)
| Revokes an interface from this environment. More...
void(* | getObjectIdentifier )(struct _uno_ExtEnvironment *pEnv, rtl_uString **ppOId, void *pInterface)
| Provides the object id of a given interface. More...
void(* | getRegisteredInterface )(struct _uno_ExtEnvironment *pEnv, void **ppInterface, rtl_uString *pOId, struct _typelib_InterfaceTypeDescription *pTypeDescr)
| Retrieves an interface identified by its object id and type from this environment. More...
void(* | getRegisteredInterfaces )(struct _uno_ExtEnvironment *pEnv, void ***pppInterfaces, sal_Int32 *pnLen, uno_memAlloc memAlloc)
| Returns all currently registered interfaces of this environment. More...
void(* | computeObjectIdentifier )(struct _uno_ExtEnvironment *pEnv, rtl_uString **ppOId, void *pInterface)
| Computes an object id of the given interface; is called by the environment implementation. More...
void(* | acquireInterface )(struct _uno_ExtEnvironment *pEnv, void *pInterface)
| Function to acquire an interface. More...
void(* | releaseInterface )(struct _uno_ExtEnvironment *pEnv, void *pInterface)
| Function to release an interface. More...

## Detailed Description

The binary specification of an UNO environment supporting interface registration.

## Member Data Documentation

## ◆ aBase

uno_Environment _uno_ExtEnvironment::aBase

inherits all members of an uno_Environment

## ◆ acquireInterface

void( * _uno_ExtEnvironment::acquireInterface) (struct _uno_ExtEnvironment *pEnv, void *pInterface)

Function to acquire an interface.

Parameters

  pEnv | corresponding environment
  pInterface | an interface

## ◆ computeObjectIdentifier

void( * _uno_ExtEnvironment::computeObjectIdentifier) (struct _uno_ExtEnvironment *pEnv, rtl_uString **ppOId, void *pInterface)

Computes an object id of the given interface; is called by the environment implementation.

Parameters

  pEnv | corresponding environment
  ppOId | out param: computed id
  pInterface | an interface

## ◆ getObjectIdentifier

void( * _uno_ExtEnvironment::getObjectIdentifier) (struct _uno_ExtEnvironment *pEnv, rtl_uString **ppOId, void *pInterface)

Provides the object id of a given interface.

Parameters

  ppOut | inout oid
  pInterface | interface of object

## ◆ getRegisteredInterface

void( * _uno_ExtEnvironment::getRegisteredInterface) (struct _uno_ExtEnvironment *pEnv, void **ppInterface, rtl_uString *pOId, struct _typelib_InterfaceTypeDescription *pTypeDescr)

Retrieves an interface identified by its object id and type from this environment.

Interfaces are retrieved in the same order as they are registered.

Parameters

  pEnv | this environment
  ppInterface | inout parameter for the registered interface; (0) if none was found
  pOId | object id of interface to be retrieved
  pTypeDescr | type description of interface to be retrieved

## ◆ getRegisteredInterfaces

void( * _uno_ExtEnvironment::getRegisteredInterfaces) (struct _uno_ExtEnvironment *pEnv, void ***pppInterfaces, sal_Int32 *pnLen, uno_memAlloc memAlloc)

Returns all currently registered interfaces of this environment.

The memory block allocated might be slightly larger than (*pnLen * sizeof(void *)).

Parameters

  pEnv | this environment
  pppInterfaces | out param; pointer to array of interface pointers
  pnLen | out param; length of array
  memAlloc | function for allocating memory that is passed back

## ◆ registerInterface

void( * _uno_ExtEnvironment::registerInterface) (struct _uno_ExtEnvironment *pEnv, void **ppInterface, rtl_uString *pOId, struct _typelib_InterfaceTypeDescription *pTypeDescr)

Registers an interface of this environment.

Parameters

  pEnv | this environment
  ppInterface | inout parameter of interface to be registered
  pOId | object id of interface
  pTypeDescr | type description of interface

## ◆ registerProxyInterface

void( * _uno_ExtEnvironment::registerProxyInterface) (struct _uno_ExtEnvironment *pEnv, void **ppProxy, uno_freeProxyFunc freeProxy, rtl_uString *pOId, struct _typelib_InterfaceTypeDescription *pTypeDescr)

Registers a proxy interface of this environment that can be reanimated and is freed explicitly by this environment.

Parameters

  pEnv | this environment
  ppInterface | inout parameter of interface to be registered
  freeProxy | function to free proxy object
  pOId | object id of interface
  pTypeDescr | type description of interface

## ◆ releaseInterface

void( * _uno_ExtEnvironment::releaseInterface) (struct _uno_ExtEnvironment *pEnv, void *pInterface)

Function to release an interface.

Parameters

  pEnv | corresponding environment
  pInterface | an interface

## ◆ revokeInterface

void( * _uno_ExtEnvironment::revokeInterface) (struct _uno_ExtEnvironment *pEnv, void *pInterface)

Revokes an interface from this environment.

You have to revoke any interface that has been registered via this method.

Parameters

  pEnv | this environment
  pInterface | interface to be revoked

The documentation for this struct was generated from the following file:

- uno/environment.h